searchNodes=[{"doc":"Reactor is a dynamic, concurrent, dependency resolving saga orchestrator. Usage You can construct a reactor using the Reactor Spark DSL: defmodule HelloWorldReactor do @moduledoc false use Reactor input :whom step :greet , Greeter do argument :whom , input ( :whom ) end return :greet end iex&gt; Reactor . run ( HelloWorldReactor , %{ whom : &quot;Dear Reader&quot; } ) { :ok , &quot;Hello, Dear Reader!&quot; } or you can build it programmatically: iex&gt; reactor = Builder . new ( ) ...&gt; { :ok , reactor } = Builder . add_input ( reactor , :whom ) ...&gt; { :ok , reactor } = Builder . add_step ( reactor , :greet , Greeter , whom : { :input , :whom } ) ...&gt; { :ok , reactor } = Builder . return ( reactor , :greet ) ...&gt; Reactor . run ( reactor , %{ whom : nil } ) { :ok , &quot;Hello, World!&quot; }","ref":"Reactor.html","title":"Reactor","type":"module"},{"doc":"","ref":"Reactor.html#default_extension_kinds/0","title":"Reactor.default_extension_kinds/0","type":"function"},{"doc":"","ref":"Reactor.html#default_extensions/0","title":"Reactor.default_extensions/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.explain/2 .","ref":"Reactor.html#explain/2","title":"Reactor.explain/2","type":"function"},{"doc":"Callback implementation for Spark.Dsl.handle_before_compile/1 .","ref":"Reactor.html#handle_before_compile/1","title":"Reactor.handle_before_compile/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.handle_opts/1 .","ref":"Reactor.html#handle_opts/1","title":"Reactor.handle_opts/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.init/1 .","ref":"Reactor.html#init/1","title":"Reactor.init/1","type":"function"},{"doc":"","ref":"Reactor.html#many_extension_kinds/0","title":"Reactor.many_extension_kinds/0","type":"function"},{"doc":"Run a reactor.","ref":"Reactor.html#run/4","title":"Reactor.run/4","type":"function"},{"doc":"","ref":"Reactor.html#single_extension_kinds/0","title":"Reactor.single_extension_kinds/0","type":"function"},{"doc":"","ref":"Reactor.html#t:context/0","title":"Reactor.context/0","type":"type"},{"doc":"","ref":"Reactor.html#t:inputs/0","title":"Reactor.inputs/0","type":"type"},{"doc":"","ref":"Reactor.html#t:options/0","title":"Reactor.options/0","type":"type"},{"doc":"","ref":"Reactor.html#t:state/0","title":"Reactor.state/0","type":"type"},{"doc":"","ref":"Reactor.html#t:t/0","title":"Reactor.t/0","type":"type"},{"doc":"A step argument.","ref":"Reactor.Argument.html","title":"Reactor.Argument","type":"module"},{"doc":"Build an argument which refers to a reactor input with an optional transformation applied. Example iex&gt; Argument . from_input ( :argument_name , :input_name , &amp; String . to_integer / 1 )","ref":"Reactor.Argument.html#from_input/3","title":"Reactor.Argument.from_input/3","type":"function"},{"doc":"Build an argument which refers to the result of another step with an optional transformation applied. Example iex&gt; Argument . from_input ( :argument_name , :step_name , &amp; Atom . to_string / 1 )","ref":"Reactor.Argument.html#from_result/3","title":"Reactor.Argument.from_result/3","type":"function"},{"doc":"Validate that the argument has a transform.","ref":"Reactor.Argument.html#has_transform/1","title":"Reactor.Argument.has_transform/1","type":"macro"},{"doc":"Validate that the argument is an Argument struct.","ref":"Reactor.Argument.html#is_argument/1","title":"Reactor.Argument.is_argument/1","type":"macro"},{"doc":"Validate that the argument refers to a reactor input.","ref":"Reactor.Argument.html#is_from_input/1","title":"Reactor.Argument.is_from_input/1","type":"macro"},{"doc":"Validate that the argument refers to a step result.","ref":"Reactor.Argument.html#is_from_result/1","title":"Reactor.Argument.is_from_result/1","type":"macro"},{"doc":"","ref":"Reactor.Argument.html#t:t/0","title":"Reactor.Argument.t/0","type":"type"},{"doc":"Template functions used to declare DSL arguments.","ref":"Reactor.Argument.Templates.html","title":"Reactor.Argument.Templates","type":"module"},{"doc":"The input template helper for the Reactor DSL. Example defmodule ExampleReactor do use Reactor input :name step :greet do # here: --------↓↓↓↓↓ argument :name , input ( :name ) impl fn %{ name : nil } , _ , _ -&gt; { :ok , &quot;Hello, World!&quot; } %{ name : name } , _ , _ -&gt; { :ok , &quot;Hello, \#{ name } !&quot; } end end end","ref":"Reactor.Argument.Templates.html#input/1","title":"Reactor.Argument.Templates.input/1","type":"function"},{"doc":"The result template helper for the Reactor DSL. Example defmodule ExampleReactor do use Reactor step :whom do impl fn -&gt; { :ok , Enum . random ( [ &quot;Marty&quot; , &quot;Doc&quot; , &quot;Jennifer&quot; , &quot;Lorraine&quot; , &quot;George&quot; , nil ] ) } end end step :greet do # here: --------↓↓↓↓↓↓ argument :name , result ( :whom ) impl fn %{ name : nil } , _ , _ -&gt; { :ok , &quot;Hello, World!&quot; } %{ name : name } , _ , _ -&gt; { :ok , &quot;Hello, \#{ name } !&quot; } end end end","ref":"Reactor.Argument.Templates.html#result/1","title":"Reactor.Argument.Templates.result/1","type":"function"},{"doc":"Build a new Reactor programmatically. You don't have to use the Reactor DSL to create a Reactor. The functions in this module allow you to define a Reactor programmatically. This is especially useful if you need to create a reactor dynamically (maybe based on a UI such as React Flow ). Example reactor = Builder . new ( ) { :ok , reactor } = Builder . add_input ( reactor , :name ) argument = Argument . from_input ( :name ) { :ok , reactor } = Builder . add_step ( reactor , :greet , [ argument ] ) { :ok , reactor } = Builder . return ( reactor , :greet )","ref":"Reactor.Builder.html","title":"Reactor.Builder","type":"module"},{"doc":"Add a named input to the Reactor. This both places the input in the Reactor for later input validation and adds steps to the Reactor which will emit and (possibly) transform the input.","ref":"Reactor.Builder.html#add_input/3","title":"Reactor.Builder.add_input/3","type":"function"},{"doc":"Add a step to the Reactor. Add a new step to the Reactor. Rewrites input arguments to use the result of the input steps and injects transformation steps as required.","ref":"Reactor.Builder.html#add_step/5","title":"Reactor.Builder.add_step/5","type":"function"},{"doc":"Build a new, empty Reactor.","ref":"Reactor.Builder.html#new/0","title":"Reactor.Builder.new/0","type":"function"},{"doc":"Build a step which can be added to a reactor at runtime. Note that the built step doesn't support argument transformations - you should add an additional step to do the transformation needed (this is what add_step/5 does anyway).","ref":"Reactor.Builder.html#new_step/4","title":"Reactor.Builder.new_step/4","type":"function"},{"doc":"Specify the return value of the Reactor. The return value must be the result of a completed step.","ref":"Reactor.Builder.html#return/2","title":"Reactor.Builder.return/2","type":"function"},{"doc":"Should the step be run asynchronously?","ref":"Reactor.Builder.html#t:async?/0","title":"Reactor.Builder.async?/0","type":"type"},{"doc":"","ref":"Reactor.Builder.html#t:impl/0","title":"Reactor.Builder.impl/0","type":"type"},{"doc":"How many times is the step allowed to retry?","ref":"Reactor.Builder.html#t:max_retries/0","title":"Reactor.Builder.max_retries/0","type":"type"},{"doc":"","ref":"Reactor.Builder.html#t:step_argument/0","title":"Reactor.Builder.step_argument/0","type":"type"},{"doc":"","ref":"Reactor.Builder.html#t:step_options/0","title":"Reactor.Builder.step_options/0","type":"type"},{"doc":"The Reactor executor. The executor handles the main loop of running a Reactor. The algorithm is somewhat confusing, so here it is in pseudocode: Find any async tasks (from a previous loop) which are completed. Either recurse or continue if none are found. Find any async steps in the plan which are ready to run (they have no in-edges in the graph) and start as many as possible (given the constraints of max_concurrency ). Either start over, or continue if none are found. Find a single synchronous step which is ready to run and execute it. If there was one then recurse, otherwise continue. Check if there are no more steps left in the plan (there are zero vertices). If so, collect the return value and exit, otherwise recurse. Whenever a step is run, whether run synchronously or asynchronously, the following happens: When the step is successful: a. If the step is undoable (ie Step.can?(module, :undo)? returns true ) then the step and the result are stored in the Reactor's undo stack. b. If the result is depended upon by another step (the graph has out-edges for the step) or the step is asking the reactor to halt then the result is stored in the Reactor's intermediate results. c. The step is removed from the graph (along with it's out-edges, freeing up it's dependents to run). When the step is unsuccessful (returns an error tuple or raises): a. If the step can be compensated then compensation is attempted up to five times before giving up. b. The reactor iterates it's undo stack calling undo on each step. When a step or compensation asks for a retry then the step is placed back in the graph to be run again next iteration.","ref":"Reactor.Executor.html","title":"Reactor.Executor","type":"module"},{"doc":"Run a reactor. Provided a Reactor which has been planned and the correct inputs, then run the Reactor until completion, halting or failure. You probably shouldn't call this directly, but use Reactor.run/4 instead.","ref":"Reactor.Executor.html#run/4","title":"Reactor.Executor.run/4","type":"function"},{"doc":"Handle the asynchronous execution of a batch of steps, along with any mutations to the reactor or execution state.","ref":"Reactor.Executor.Async.html","title":"Reactor.Executor.Async","type":"module"},{"doc":"When the Reactor needs to shut down for any reason, we need to await all the currently running asynchronous steps and delete any task vertices.","ref":"Reactor.Executor.Async.html#collect_remaining_tasks_for_shutdown/2","title":"Reactor.Executor.Async.collect_remaining_tasks_for_shutdown/2","type":"function"},{"doc":"Check to see if any steps are completed, and if so handle them.","ref":"Reactor.Executor.Async.html#handle_completed_steps/2","title":"Reactor.Executor.Async.handle_completed_steps/2","type":"function"},{"doc":"Start as many of the provided steps as possible. Takes into account he maximum concurrency and available work slots.","ref":"Reactor.Executor.Async.html#start_steps/4","title":"Reactor.Executor.Async.start_steps/4","type":"function"},{"doc":"Handle argument checking and state setup for a Reactor run.","ref":"Reactor.Executor.Init.html","title":"Reactor.Executor.Init","type":"module"},{"doc":"Contains the reactor execution state. This is run-time only information.","ref":"Reactor.Executor.State.html","title":"Reactor.Executor.State","type":"module"},{"doc":"","ref":"Reactor.Executor.State.html#t:t/0","title":"Reactor.Executor.State.t/0","type":"type"},{"doc":"Run an individual step, including compensation if possible.","ref":"Reactor.Executor.StepRunner.html","title":"Reactor.Executor.StepRunner","type":"module"},{"doc":"Collect the arguments and and run a step, with compensation if required.","ref":"Reactor.Executor.StepRunner.html#run/2","title":"Reactor.Executor.StepRunner.run/2","type":"function"},{"doc":"Undo a step if possible.","ref":"Reactor.Executor.StepRunner.html#undo/3","title":"Reactor.Executor.StepRunner.undo/3","type":"function"},{"doc":"Handle the synchronous execution of a single step, along with any mutations to the reactor or execution state.","ref":"Reactor.Executor.Sync.html","title":"Reactor.Executor.Sync","type":"module"},{"doc":"Try and run a step synchronously.","ref":"Reactor.Executor.Sync.html#run/3","title":"Reactor.Executor.Sync.run/3","type":"function"},{"doc":"Introspection for the Reactor DSL.","ref":"Reactor.Info.html","title":"Reactor.Info","type":"module"},{"doc":"reactor DSL entities","ref":"Reactor.Info.html#reactor/1","title":"Reactor.Info.reactor/1","type":"function"},{"doc":"reactor DSL options Returns a map containing the and any configured or default values.","ref":"Reactor.Info.html#reactor_options/1","title":"Reactor.Info.reactor_options/1","type":"function"},{"doc":"Convert a reactor DSL module into a reactor struct.","ref":"Reactor.Info.html#to_struct/1","title":"Reactor.Info.to_struct/1","type":"function"},{"doc":"The struct used to store input DSL entities.","ref":"Reactor.Input.html","title":"Reactor.Input","type":"module"},{"doc":"","ref":"Reactor.Input.html#t:t/0","title":"Reactor.Input.t/0","type":"type"},{"doc":"Build an execution plan for a Reactor. Converts any unplanned steps into vertices in a graph with directed edges between them representing their dependencies (arguments).","ref":"Reactor.Planner.html","title":"Reactor.Planner","type":"module"},{"doc":"Build an execution plan for a Reactor. Builds a graph of the step dependencies, resolves them and then builds an execution plan.","ref":"Reactor.Planner.html#plan/1","title":"Reactor.Planner.plan/1","type":"function"},{"doc":"The struct used to store steps.","ref":"Reactor.Step.html","title":"Reactor.Step","type":"behaviour"},{"doc":"Capability discovery callback. Return true for the capabilities that your step supports. See t:capability for a list of all capabilities.","ref":"Reactor.Step.html#c:can?/1","title":"Reactor.Step.can?/1","type":"callback"},{"doc":"Find out of a step has a capability.","ref":"Reactor.Step.html#can?/2","title":"Reactor.Step.can?/2","type":"function"},{"doc":"Compensate a step","ref":"Reactor.Step.html#compensate/4","title":"Reactor.Step.compensate/4","type":"function"},{"doc":"Compensate for the failure of the step. If run/3 returned an error then this callback will be called the error reason and the original arguments. This provides you the opportunity to handle the error in a number of ways and direct the reactor as to what to do next. This callback is only called if can?/1 returns true for the :compensate capability. Arguments reason - the error reason returned from run/3 . arguments - the arguments passed to the step. context - the reactor context. options - a keyword list of options provided to the step (if any). Return values {:continue, value} if you're able to provide a valid result for the step (perhaps by re-running the original computation) then return that within a :continue tuple and execution will continue as planned. :ok the step was successfully compensated and the reactor should continue undoing upstream changes. :retry if you would like the reactor to attempt to re-run the step.","ref":"Reactor.Step.html#c:compensate/4","title":"Reactor.Step.compensate/4","type":"callback"},{"doc":"Execute a step.","ref":"Reactor.Step.html#run/3","title":"Reactor.Step.run/3","type":"function"},{"doc":"Execute the step. This is the function that implements the behaviour you wish to execute. You will receive arguments as per the t:Step.t definition along with their corresponding values as a map and a copy of the current reactor context. Arguments arguments - A map of arguments as per the t:Step.t definition we're called from. context - The reactor context. options - A keyword list of options provided to the step (if any). Return values {:ok, value} the step completed successfully it returns the value in an ok tuple. {:ok, value, [step]} the step completed successfully and wants to add new steps to the reactor. {:error, reason} the if step failed, return an error tuple. {:halt, reason} terminate (or pause) reactor execution. If there are actively running steps the reactor will wait for them to finish and then return the incomplete state for later resumption.","ref":"Reactor.Step.html#c:run/3","title":"Reactor.Step.run/3","type":"callback"},{"doc":"Undo a step","ref":"Reactor.Step.html#undo/4","title":"Reactor.Step.undo/4","type":"function"},{"doc":"Undo a previously successful execution of the step. This callback is called when the reactor encounters an unhandled error later in it's execution run and must undo the work previously done. This callback is only called if can?/1 returns true for the :undo capability. Arguments value - the return value of the previously successful call to run/3 . arguments - the arguments passed to the step. context - the reactor context. options - a keyword list of options provided to the step (if any). Return values :ok the step was successfully undo and the reactor should continue rolling back. {:error, reason} there was an error while attempting to compensate. The reactor will collect the error and continue rolling back. :retry if you would like the reactor to attempt to undo the again later possibly in the case of a network failure for example.","ref":"Reactor.Step.html#c:undo/4","title":"Reactor.Step.undo/4","type":"callback"},{"doc":"Optional capabilities which may be implemented by the step module. This allows us to optimise out calls steps which cannot be undone, etc.","ref":"Reactor.Step.html#t:capability/0","title":"Reactor.Step.capability/0","type":"type"},{"doc":"Possible valid return values for the compensate/4 callback.","ref":"Reactor.Step.html#t:compensate_result/0","title":"Reactor.Step.compensate_result/0","type":"type"},{"doc":"Possible valid return values for the run/3 callback.","ref":"Reactor.Step.html#t:run_result/0","title":"Reactor.Step.run_result/0","type":"type"},{"doc":"","ref":"Reactor.Step.html#t:t/0","title":"Reactor.Step.t/0","type":"type"},{"doc":"Possible valid return values for the undo/4 callback.","ref":"Reactor.Step.html#t:undo_result/0","title":"Reactor.Step.undo_result/0","type":"type"},{"doc":"The built-in step for executing in-line DSL anonymous functions. This step assumes that it is being called as per the :spark_function_behaviour semantics.","ref":"Reactor.Step.AnonFn.html","title":"Reactor.Step.AnonFn","type":"module"},{"doc":"Callback implementation for Reactor.Step.compensate/4 .","ref":"Reactor.Step.AnonFn.html#compensate/4","title":"Reactor.Step.AnonFn.compensate/4","type":"function"},{"doc":"Callback implementation for Reactor.Step.undo/4 .","ref":"Reactor.Step.AnonFn.html#undo/4","title":"Reactor.Step.AnonFn.undo/4","type":"function"},{"doc":"A built-in step which emits a reactor input.","ref":"Reactor.Step.Input.html","title":"Reactor.Step.Input","type":"module"},{"doc":"Callback implementation for Reactor.Step.compensate/4 .","ref":"Reactor.Step.Input.html#compensate/4","title":"Reactor.Step.Input.compensate/4","type":"function"},{"doc":"Callback implementation for Reactor.Step.undo/4 .","ref":"Reactor.Step.Input.html#undo/4","title":"Reactor.Step.Input.undo/4","type":"function"},{"doc":"The built-in step for executing input and argument transformations. This step assumes that it is being executed as per :spark_function_behaviour semantics.","ref":"Reactor.Step.Transform.html","title":"Reactor.Step.Transform","type":"module"},{"doc":"Callback implementation for Reactor.Step.compensate/4 .","ref":"Reactor.Step.Transform.html#compensate/4","title":"Reactor.Step.Transform.compensate/4","type":"function"},{"doc":"Callback implementation for Reactor.Step.undo/4 .","ref":"Reactor.Step.Transform.html#undo/4","title":"Reactor.Step.Transform.undo/4","type":"function"},{"doc":"The input template.","ref":"Reactor.Template.Input.html","title":"Reactor.Template.Input","type":"module"},{"doc":"","ref":"Reactor.Template.Input.html#t:t/0","title":"Reactor.Template.Input.t/0","type":"type"},{"doc":"The result template.","ref":"Reactor.Template.Result.html","title":"Reactor.Template.Result","type":"module"},{"doc":"","ref":"Reactor.Template.Result.html#t:t/0","title":"Reactor.Template.Result.t/0","type":"type"},{"doc":"Reactor is a dynamic, concurrent, dependency resolving saga orchestrator. Woah. That's a lot. Let's break it down: Saga orchestrator A [saga][saga pattern] is a way of providing transaction-like semantics across multiple distinct resources. Dependency resolving reactor allows you to describe the dependencies between your saga steps using arguments which are converted into a DAG and used to compute execution order. Concurrent unless otherwise specified reactor will run as many steps as possible concurrently whilst taking into account the results of the dependency resolution. Dynamic whilst you can define a reactor statically using our awesome DSL, you can also build workflows dynamically - and even add steps while the reactor is running. saga pattern","ref":"readme.html","title":"Reactor","type":"extras"},{"doc":"The package can be installed by adding reactor to your list of dependencies in mix.exs : def deps do [ { :reactor , &quot;~&gt; 0.2.0&quot; } ] end","ref":"readme.html#installation","title":"Reactor - Installation","type":"extras"},{"doc":"Documentation for the latest release will be available on hexdocs and for the main branch .","ref":"readme.html#documentation","title":"Reactor - Documentation","type":"extras"},{"doc":"To contribute updates, fixes or new features please fork and open a pull-request against main . Please use conventional commits - this allows us to dynamically generate the changelog. Feel free to ask any questions on the #reactor channel on the Ash Discord .","ref":"readme.html#contributing","title":"Reactor - Contributing","type":"extras"},{"doc":"reactor is licensed under the terms of the MIT license . See the LICENSE file in this repository for details. saga pattern","ref":"readme.html#licence","title":"Reactor - Licence","type":"extras"}]